// imagechanger2.js
//
// Author:  Br. David Carlson
//
// Cycles 5 times through 3 images displayed on imagechanger2.html with a fade out of each
// previous image followed by a fade in of the new image.  It then ends on the first image.
// Uses the general ideas of the fade method shown in this article:
// http://www.itnewb.com/tutorial/Cross-Browser-CSS-Opacity-and-the-JavaScript-Fade-Fading-Effect
// However, the approach here uses recursion instead of loops.


// Change the opacity to that given by the parameter OpacityNum.
function SetOpacity(OpacityNum, domImage)
   {
   domImage.style.opacity = OpacityNum / 100.0;
   domImage.style.filter = 'alpha(opacity=' + OpacityNum + ')';
   }


// Changes the image every 5 seconds, with a fade out and a fade in that add 1 second each.
function CycleImages()
   {
   var NumImages = 3;  // adjust this to the number of images you have to cycle through
   var CurrentNum = 1;
   var NumCycles = 0;  // zero cycles through the images have been completed at this point
   var domImage = document.getElementById("airplane");
   var Opacity = 100;
   SetOpacity(Opacity, domImage);
   setTimeout(function() { FadeOut(Opacity, NumImages, CurrentNum, NumCycles, domImage) }, 5000);   // After 5 seconds, call FadeOut.
   }


// Lower the opacity to 0 over the course of 1 second, then call ChangeImage().
function FadeOut(Opacity, NumImages, CurrentNum, NumCycles, domImage)
   {
   if (NumCycles == 5)
      return;

   if (Opacity > 0)
      {
      Opacity -= 5;
      SetOpacity(Opacity, domImage);
      setTimeout(function() { FadeOut(Opacity, NumImages, CurrentNum, NumCycles, domImage) }, 50);  // After 1/20-th of a second...
      }
   else
      NextImage(Opacity, NumImages, CurrentNum, NumCycles, domImage); 
   }


// Display the next image (with wrap around from the last to the first image), then call FadeIn.
function NextImage(Opacity, NumImages, CurrentNum, NumCycles, domImage)
   {
   CurrentNum++;
   if (CurrentNum > NumImages)
      {
      CurrentNum = 1;
      NumCycles++;
      }

   domImage.setAttribute("src", "airplane" + CurrentNum + ".png");
   FadeIn(Opacity, NumImages, CurrentNum, NumCycles, domImage);
   }


// Raise the Opacity to 100 over the course of 1 second, then after 5 seconds, call FadeOut.
function FadeIn(Opacity, NumImages, CurrentNum, NumCycles, domImage)
   {
   if (Opacity < 100)
      {
      Opacity += 5;
      SetOpacity(Opacity, domImage);
      setTimeout(function() { FadeIn(Opacity, NumImages, CurrentNum, NumCycles, domImage) }, 50);  // After 1/20-th of a second...
      }
   else
      setTimeout(function() { FadeOut(Opacity, NumImages, CurrentNum, NumCycles, domImage) }, 5000);   // After 5 seconds call FadeOut.
   }
